#!/bin/bash


if [ $# -ne 1 ]
then
	echo "usage: ./transform.sh inputfile"
	exit 1
fi

if [ ! -f $1 ]
then
	echo "$1: no such file or directory"
	exit 1
fi

if [ ! -w $1 ]
then
	echo "$1 is write-protected"
	exit 1
fi

file=`echo $1 | sed 's/\.dia/\.aml/g'`
touch $file;

if [ "$1" = "$file" ]
then
	echo "input file name  does not end in '.dia'"
	exit 1;
fi

if [ ! -w $file ]
then
	echo "output file $file cannot be written"
	exit 1
fi

orig="$1____orig"

#test if g-zipped
gzip -t $1

if [ $? -eq 0 ]
then
	# move for correct input file name
	mv $1 $orig

	#unzip
	gzip -d -c $orig > $1

	saxonb-xslt -w1 -ext:on $1 Dia2CAEX.xsl > $file

	# delete unzipped copy
	rm $1

	#move back
	mv $orig $1
else
	saxonb-xslt -w1 -ext:on $1 Dia2CAEX.xsl > $file
fi
